<template>
  <div class="profile-setting">
    <div class="title-page">
      {{ $t('profile_setting.title') }}
    </div>
    <div class="content-box">
      <div class="user">
        <span class="iconmo iconmo-KYC"></span>
        <div class="description">
          <p class="kyc-status">
            <span class="text">{{ $t('profile_setting.kyc_status') }}</span>
            <label v-if="user.kyc_status >= 0" class="alert" :class="kycStatus[user.kyc_status]">{{ kycStatus[user.kyc_status] }}</label>
            <button type="button" class="btn-change" @click="$router.push('/users/kyc')" v-if="!user.kyc_status">
              {{ $t('profile_setting.btn_verify') }}
            </button>
          </p>
          <p class="suggest" v-html="$t('profile_setting.kyc_status.note', {optional: '<br>'})"></p>
        </div>
      </div>
      <div class="clearfix"></div>
      <div class="change_password change">
        <span class="iconmo iconmo-password"></span>
        <div class="change-description">
          <h6>{{ $t('profile_setting.login_password') }}</h6>
        </div>
        <button type="button" class="btn-change" @click="$router.push('/users/profileSetting/change-password')">{{ $t('profile_setting.btn_change') }}</button>
      </div>

      <div class="authentication change">
        <span class="iconmo iconmo-google"></span>
        <div class="change-description">
          <h6>{{ $t('profile_setting.authentication.title') }}</h6>
        </div>
        <button type="button" class="btn-change" v-if="user.two_factor_enabled" @click="openModalConfirm()">{{ $t('profile_setting.btn_disable') }}</button>
        <button type="button" class="btn-change" v-else @click="$router.push('/users/profileSetting/2FA')">{{ $t('profile_setting.btn_enable') }}</button>
      </div>

      <div class="token_address change">
        <span class="iconmo iconmo-ETH_1"></span>
        <div class="change-description">
          <h6 :class="{ 'currency-address': user.token_address }">
            {{ user.token_address || $t('profile_setting.token_address.label') }}
          </h6>
        </div>
        <button type="button" class="btn-change" @click="openChangeAddressModal('token')"><i class="fa fa-edit"></i></button>
      </div>

      <div class="referral">
        <div class="referral_qr">
          <qrcode class="qrcode" :value="urlReferral"></qrcode>
        </div>
        <div class="referral_info">
          <div class="referral_id">
            <span>{{ $t('profile_setting.referral.id') }} </span>
            <span class="referral___id">{{ user.referral_id }}</span>
          </div>
          <div class="link">
            <span>{{ $t('profile_setting.referral.link') }}</span>
            <div class="referral_link">
              <a :href="urlReferral" target="_blank">{{ urlReferral }}</a>
              <button type="button" v-clipboard:copy="urlReferral" @click="isShowTooltip = !isShowTooltip"
                 v-tooltip="{content: 'Copied', trigger: 'click',boundariesElement: 'window',show: isShowTooltip , classes: ['hide', 'hideAnim']}"><span class="iconmo iconmo-copy"></span></button>
            </div>
          </div>
        </div>
      </div>
      <div class="content-bottom">
        <div class="number-box">
          <span class="name">{{ $t('profile_setting.referral.registered') }}</span>
          <span class="number">{{ user.referrees }}</span>
        </div>
        <div class="number-box">
          <span class="name">{{ $t('profile_setting.referral.kyc') }}</span>
          <span class="number">{{ user.kycs }}</span>
        </div>
        <div class="number-box">
          <span class="name">{{ $t('profile_setting.referral.deposited') }}</span>
          <span class="number">{{ user.deposit }}</span>
        </div>
      </div>

      <div v-for="currency in currencies" :class="`${currency}_address change`">
        <span class="iconmo"><img :src="currency | currencyIcon"></span>
        <div class="change-description">
          <span :class="{'currency-address': user[`${currency}_address`]}">
            {{ user[`${currency}_address`] || $t(`profile_setting.${currency}_address.label`) }}
          </span>
        </div>
        <button type="button" class="btn-change" @click="openChangeAddressModal(currency)"><i class="fa fa-edit"></i></button>
      </div>


      <div class="btn-logout change">
        <div class="change-description" @click="$refs.logoutForm.submit()">
          <span><span>{{ $t('profile_setting.btn_logout') }}</span> <span class="iconmo iconmo-export"></span></span>
        </div>
        <form :action="`${$baseUrl}/logout`" ref="logoutForm" style="display: none" method="post">
          <input type="hidden" name="_token" :value="$csrfToken">
        </form>
      </div>
    </div>
  </div>
</template>
<script>
import { mapState, mapMutations } from 'vuex';

import ChangeCurrencyAddressModal from '../components/Modal/ChangeCurrencyAddressModal.vue';
import RemoveOtpModal from '../components/Modal/RemoveOtpModal.vue';

export default {
  data (){
    return {
      currencies: ['eth', 'btc', 'usdt'],
      kycStatus: ['unverified', 'pending', 'verified', 'rejected'],
      isShowTooltip: false,
    }
  },
  computed: {
    ...mapState([
      'user',
    ]),
    urlReferral () {
      return this.user ? `${this.$baseUrl}/register?referral_id=${this.user.referral_id}` : '';
    },
  },
  methods: {
    ...mapMutations([
      'updateUser'
    ]),
    openChangeAddressModal (currency) {
      this.$broadcast('open-modal', ChangeCurrencyAddressModal, { currency });
    },
    openModalConfirm () {
      this.$broadcast('open-modal', RemoveOtpModal);
    },
  },
  created () {
    this.$on('requestChangeETHAddress-confirm-otp-successful', (res) => {
      this.updateUser(res.data);
      this.$toasted.show('Update ETH address successful!', {
        theme: 'bubble',
        position: 'top-right',
        duration : 2000
      });
    });

    this.$on('requestChangeBTCAddress-confirm-otp-successful', (res) => {
      this.updateUser(res.data);
      this.$toasted.show('Update BTC address successful!', {
        theme: 'bubble',
        position: 'top-right',
        duration : 2000
      });
    });

    this.$on('requestChangeUSDTAddress-confirm-otp-successful', (res) => {
      this.updateUser(res.data);
      this.$toasted.show('Update USDT address successful!', {
        theme: 'bubble',
        position: 'top-right',
        duration : 2000
      });
    });
  },
}
</script>

<style lang="scss" scoped>
  @import '../../../sass/mobile/typoVariables.scss';

  * {
    font-family: $font-family-home;
  }
  .profile-setting {
    background: $bg_primary;
    height: auto;
    .title-page {
      padding: 13rem 12rem 13rem;
      background-image: linear-gradient(to bottom, $midnight, $catalina_blue);
      box-shadow: 0 2rem 40rem 0 rgba(0, 0, 0, 0.5);
      font-size: 18rem;
      color: $white;
    }

    .title-page,
    .content-box {
      padding-left: 12rem;
      padding-right: 12rem;
    }
    .content-box {
      background-color: $bg_primary;
      height: 100%;
      padding-top: 30rem;
      .user {
        width: 100%;
        padding: 19rem 16rem 16rem;
        height: 100rem;
        background: #e8e8e8;
        border-radius: 8rem;
        .iconmo {
          width: 20rem;
          font-size: 20rem;
          float: left;
        }
        .description {
          width: calc(100% - 20rem);
          float: left;
          position: relative;
          padding-left: 9rem;
          .kyc-status {
            font-size: 14rem;
            font-weight: bold;
            font-style: normal;
            font-stretch: normal;
            line-height: normal;
            letter-spacing: normal;
            color: #505050;
            display: table;
            .text {
              font-size: $small;
              display: table-cell;
              vertical-align: middle;
              width: 80rem;
            }
            .alert {
              text-transform: uppercase;
              padding: 4rem 0 0;
              margin: 0 0 0rem 1rem;
              width: 82rem;
              height: 20rem;
              border-radius: 30rem;
              background-color: #4a90e2;
              font-size: 10rem;
              font-weight: bold;
              text-align: center;
              color: #ffffff;
              &.pending {
                background-color: #fcb202;
              }
              &.verified {
                background-color: #4caf50;
              }
              &.rejected {
                background-color: #d0021b;
              }
            }
            .btn-change {
              position: absolute;
              width: 51rem;
              height: 14rem;
              background-color: #e8e8e8;
              font-size: 12rem;
              font-weight: bold;
              letter-spacing: 0.5rem;
              border: none;
              color: #fa7300;
              text-transform: uppercase;
              transform: translate(-50%,-50%);
              top: 10rem;
              right: -30rem;
              cursor: pointer;
              outline: none;
              margin-top: -2rem;
            }
          }
          .suggest {
            font-size: 14rem;
            font-weight: normal;
            font-style: normal;
            font-stretch: normal;
            line-height: normal;
            letter-spacing: normal;
            margin-top: 3rem;
            color: #989898;
          }
        }
      }
    }
    .change {
      width: 100%;
      height: 50rem;
      border-radius: 74rem;
      border: none;
      background-color: #e8e8e8;
      display: table;
      padding: 0 18rem 0 15rem;
      position: relative;
      .btn-change {
        position: absolute;
        width: 51rem;
        height: 14rem;
        background-color: #e8e8e8;
        font-size: 12rem;
        font-weight: bold;
        letter-spacing: 0.5rem;
        border: none;
        color: #fa7300;
        text-transform: uppercase;
        transform: translate(-50%,-50%);
        top: 50%;
        right: -5rem;
        cursor: pointer;
        outline: none;
        margin-top: -2rem;
      }
      &.change_password,
      &.authentication {
        margin-top: 10rem;
      }
      &.token_address {
        margin: 10rem 0 31rem;
        .btn-change {
          width: auto;
          right: 5rem;
          padding: 0;
          .fa-edit {
            cursor: pointer;
            font-family: FontAwesome;
          }
        }
        @media screen and (min-width: 374rem) {
          h6.currency-address {
            font-size: 11rem !important;
          }
        }
        @media screen and (min-width: 400rem) {
          h6.currency-address {
            font-size: 13rem !important;
          }
        }
        h6.currency-address {
          font-size: 10rem;
        }
      }
      &.eth_address,
      &.btc_address,
      &.usdt_address,{
        .btn-change {
          width: auto;
          right: 5rem;
          padding: 0;
          .fa-edit {
            cursor: pointer;
            font-family: FontAwesome;
          }
        }
        @media screen and (min-width: 374rem) {
          span.currency-address {
            font-size: 11rem !important;
          }
        }
        @media screen and (min-width: 400rem) {
          span.currency-address {
            font-size: 13rem !important;
          }
        }
        span.currency-address {
          font-size: 10rem;
        }
      }
      &.eth_address {
        margin-top: 30rem;
      }
      &.btc_address {
        margin-top: 10rem;
      }
      &.usdt_address {
        margin-top: 10rem;
      }
      &.btn-logout {
        margin: 23rem 0;
        height: 40rem;
        background-color: #fa7300;
        cursor: pointer;
        text-align: center;
        .change-description {
          span {
            font-size: 14rem;
            @extend .bold--18;
            font-weight: bold;
            text-transform: uppercase;
            color: #ffffff;
            margin-right: -9rem;
            &.iconmo {
              font-size: 11rem;
              font-weight: normal;
              margin-left: 10rem;
              &:before {
                position: absolute;
                top: 50%;
                transform: translate(-50%, -50%);
              }
            }
          }
        }
      }
      .change-description {
        padding-left: 1rem;
        vertical-align: middle;
        display: table-cell;
        h6 {
          margin: 0;
          font-size: 14rem;
          color: $black;
        }
        span {
          font-size: 14rem;
          color: #989898;
        }
      }
      .iconmo {
        font-size: 30rem;
        display: table-cell;
        width: 30rem;
        vertical-align: middle;
        img {
          width: 100%;
        }
      }
    }
    .referral {
      height: 136rem;
      border-top: 1rem solid #e0e0e0;
      border-bottom: 1rem solid #e0e0e0;
      padding: 14rem 0 20rem;
      .referral_qr {
        width: 80rem;
        heigh: 80rem;
        float: left;
        .qrcode {
          width: 100%;
        }
      }
      .referral_id {
        margin-bottom: 8rem;
      }
      .referral_info {
        width: calc(100% - 80rem);
        float: left;
        padding-left: 5rem;
        span {
          font-size: 14rem;
          color: #989898;
          &.referral___id {
            color: #505050;
            @extend .bold--18;
            font-weight: bold;
          }
        }
        .referral_link {
          font-size: 14rem;
          position: relative;
          width: calc(100% - 14rem);
          a {
            word-break: break-all;
            font-size: 14rem;
            @extend .bold--18;
            color: #505050;
            text-decoration: underline;
            font-weight: bold;
          }
          button {
            width: 14rem;
            height: 14rem;
            border: none;
            background: none;
            text-align: center;
            padding: 0rem;
            position: absolute;
            top: 50%;
            right: -20rem;
            transform: translate(-50%, -50%);
            .iconmo {
              &:before {
                color: #989898;
              }
            }
          }
        }
      }
    }
    .content-bottom {
      margin-top: 23rem;
      .number-box {
        margin: 13rem 0;
        height: 16rem;
        position: relative;
        .name {
          line-height: 16rem;
          font-size: 14rem;
          color: #989898;
        }
        .number {
          line-height: 16rem;
          font-size: 16rem;
          @extend .bold--18;
          color: #505050;
          position: absolute;
          right: 0;
          font-weight: bold;
        }
      }
    }
  }
</style>
